/*
 * Copyright (C) 2010  Peter Bailis <pbailis@eecs.harvard.edu>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#define DEFAULT_TIME 1000
#define DEFAULT_WORLDSIZE 500
#define DEFAULT_NUMBEES 500
#define DEFAULT_NUMFLOWERS 500

#define DEFAULT_NECTAR_PER_HARVEST 1

#define DEFAULT_BEE_SENSING_NOISE .02
#define DEFAULT_BEE_ACTUATION_NOISE .02

#define DEFAULT_SHARE_POSITIONAL_INFORMATION 1
#define DEFAULT_BEE_DANCE_LENGTH_MULTIPLIER 50

#define DEFAULT_BEE_FLIGHT_SPEED 1

#define DEFAULT_BEE_COLONY_SIGHT_RADIUS 10
#define DEFAULT_UNEMPLOYED_SCOUT_PROBABILITY .1

#define DEFAULT_SPIRAL_ANGULAR_VELOCITY_CHANGE 10
#define DEFAULT_SPIRAL_VELOCITY_INCREASE 10

#define DEFAULT_ENERGY_TO_REPLENISH DEFAULT_WORLDSIZE
#define DEFAULT_DANCE_LENGTH_MULTIPLIER 50

#define DEFAULT_NUM_FOLLOWERS_PER_DANCER_PER_TIMESTEP 1

#define DEFAULT_FLOWER_LIFE 800
#define DEFAULT_FLOWER_QUANTITY 20
#define DEFAULT_FLOWER_QUALITY 1


#define DEFAULT_BEE_VISION_RADIUS 1

//how close should we be to be equal locations
#define DEFAULT_LOCATION_ACCURACY .05

#define DEFAULT_LOGFILE "beelog.txt"

#define LOGDOCSTRING "\
# FORMAT:\n\
#\n\
# World:\n\
# W <size>\n\
# Timestep:\n\
# T <step>\n\
#\n\
# Bee:\n\
# B <id> <type> <xpos> <ypos>\n\
# types:\n\
#     F (forager)\n\
#     F+ (forager with food)\n\
#     S (scout)\n\
#\n\
# Flower:\n\
# F <id> <xpos> <ypos>\n\
# or\n\
# F <id> D\n\
# (flower is dead)\n\
#\n\
# at end, print total food, energy\n"
