/*
 * Copyright (C) 2010  Peter Bailis <pbailis@eecs.harvard.edu>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef FLOWER_H
#define FLOWER_H

#include "Position.h"

class Flower
{
    public:
        Flower(const unsigned id, Position *, unsigned lifespan, unsigned initialQuantity, unsigned inputQuality);
        ~Flower();

        const Position *getPosition(void) const;

        void updateFlower(void);

        const unsigned harvestNectar(void);
        const bool isDead(void);
        const bool canDelete(void);
        const unsigned getId(void);

        const unsigned getQuality(void) const;
        const int getQuantity(void) const;

        //we may want to remove it as dead before we actually
        //garbage collect it!
        //the compiler won't let me #ifdef DEBUG this one...
        const bool shouldMarkDead(void);

    private:
        bool isLoggedAsDead;

        unsigned myId;
        Position *myPosition;
        int nectarRemaining;
        //when zero, dies
        int ageLeft;
        unsigned quality;
};

#endif // FLOWER_H
