/*
 * Copyright (C) 2010  Peter Bailis <pbailis@eecs.harvard.edu>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef POSITION_H
#define POSITION_H

#include <stdlib.h>

class Position
{
    public:
        Position(float x, float y);
        ~Position();

        float getDistance(const Position &toCompare) const;
        float getAbsoluteSlope(const Position &toCompare) const;
        //return in radians
        float getAngle(const Position &) const;

        float getXCoord() const;
        float getYCoord() const;

        void setXCoord(float);
        void setYCoord(float);
        void incrementXCoord(float);
        void incrementYCoord(float);

    bool operator==(const Position &other) const;

    private:
        float xCoord, yCoord;

};

#endif // POSITION_H
