'''
 Copyright (C) 2010  Peter Bailis <pbailis@eecs.harvard.edu>

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

from settings import *

WORLDSIZE = 500
MINFLOWERLIFE = 500
MAXFLOWERLIFE = 10000
MINFLOWERNECTAR = 1
TIMESUPPORTED = 300000

HIGHQUALITYNECTARVALUE = 4
LOWQUALITYNECTARVALUE = 1

#patchy or uniform

ColonyX = WORLDSIZE/2
ColonyY = WORLDSIZE/2


### Implementation starts here.

from random import *
from sys import argv

#important! do not delete!!!
seed(argv[1])

id = 0
flowercoords = []


print "# Worldsize"
print WORLDSIZE

print "# Colony: C x y"
print "C"+" "+str(ColonyX)+" "+str(ColonyY)

print "# Bees: B id x y role"

for bee in range(0, NBEES):
    if bee < NBEES/10:
        role = "SCOUT"
    else:
        role = "FORAGER"

    print "B "+str(id)+" "+str(ColonyX)+" "+str(ColonyY)+" "+role
    id += 1

print "# Flowers: F id x y life nectar"

patchCenters = []
for i in range(0, NUMPATCHES):
    if random() < HIGHQUALITYNECTAR:
        quality = HIGHQUALITYNECTARVALUE
    else:
        quality = LOWQUALITYNECTARVALUE
    patchCenters.append([randint(0, WORLDSIZE), randint(0, WORLDSIZE), quality])

for flower in range(0, NFLOWERS):
    if WORLDKIND == "scattered":
        xCoord = randint(0, WORLDSIZE)
        yCoord = randint(0, WORLDSIZE)

        if(random() < HIGHQUALITYNECTAR):
            quality = HIGHQUALITYNECTARVALUE
        else:
            quality = LOWQUALITYNECTARVALUE

    else:
        chosenPatch = patchCenters[randint(0, NUMPATCHES-1)]
        quality = chosenPatch[2]

        xCoord = chosenPatch[0] + normalvariate(0.01, FLOWERREGENERATIONSTDDEV)
        yCoord = chosenPatch[1] + normalvariate(0.01, FLOWERREGENERATIONSTDDEV)

        if xCoord > WORLDSIZE:
            xCoord -= WORLDSIZE
        elif xCoord < 0:
            xCoord = -xCoord
        if yCoord > WORLDSIZE:
            yCoord -= WORLDSIZE
        elif yCoord < 0:
            yCoord = -yCoord
            

    flowercoords.append([xCoord, yCoord])
    life = randint(MINFLOWERLIFE,
                   MAXFLOWERLIFE)
    quantity = MAXFLOWERNECTAR#randint(MINFLOWERNECTAR, MAXFLOWERNECTAR)
   
    print ("F "+str(id)+" "+str(xCoord)+" "+
           str(yCoord)+" "+str(life)+" "+str(quantity)+" "+str(quality))
    id += 1

for i in range(0, TIMESUPPORTED):
    if not (i % FLOWERREGENERATION):
        if(WORLDKIND == "scattered"):
            newcoord = flowercoords[randint(0, len(flowercoords)-1)]
            if(random() < HIGHQUALITYNECTAR):
                quality = HIGHQUALITYNECTARVALUE
            else:
                quality = LOWQUALITYNECTARVALUE

            xCoord = randint(0, WORLDSIZE)
            yCoord = randint(0, WORLDSIZE)

        else:
            if(random() < probnewpatch):
                if(random() < HIGHQUALITYNECTAR):
                    quality = HIGHQUALITYNECTARVALUE
                else:
                    quality = LOWQUALITYNECTARVALUE
                patchCenters.append([randint(0, WORLDSIZE), 
                                     randint(0, WORLDSIZE), quality])
                NUMPATCHES += 1
            chosenPatch = patchCenters[randint(0, NUMPATCHES-1)]
            newcoord = [chosenPatch[0], chosenPatch[1]]
            quality = chosenPatch[2]


            xCoord = newcoord[0]
            yCoord = newcoord[1]

            xCoord += normalvariate(0.01, FLOWERREGENERATIONSTDDEV)
            yCoord += normalvariate(0.01, FLOWERREGENERATIONSTDDEV)

            if xCoord > WORLDSIZE:
                xCoord -= WORLDSIZE
            elif xCoord < 0:
                xCoord = -xCoord
            if yCoord > WORLDSIZE:
                yCoord -= WORLDSIZE
            elif yCoord < 0:
                yCoord = -yCoord
            
        newcoord[0] = xCoord
        newcoord[1] = yCoord

        life = randint(MINFLOWERLIFE,
                       MAXFLOWERLIFE)
        quantity = MAXFLOWERNECTAR#randint(MINFLOWERNECTAR, MAXFLOWERNECTAR)

        print ("NF "+str(id)+" "+str(xCoord)+" "+
               str(yCoord)+" "+str(life)+" "+str(quantity)+
               " "+str(quality)+" "+str(i))
        id += 1

print "#",
for patch in patchCenters:
    print str(patch[0])+" "+str(patch[1])+" ",
print
