'''
 Copyright (C) 2010  Peter Bailis <pbailis@eecs.harvard.edu>

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

from Tkinter import *
from sys import argv

beesize = 1
foragercolor = "black"
foragerfoodcolor = "red"
scoutcolor = "blue"
flowersize = 1
lowqualityflowercolor = "brown"
highqualityflowercolor = "tan"
lowflowerquality = 1

if len(argv) < 2:
    filename = "beelog.txt"
else:
    filename = argv[1]

logfile = open(filename)

master = Tk()
master.title("Playback of log "+filename)

#will be replaced with world once we know size
wcanvas = None

bees = {}
flowers = {}

for txtline in logfile:
    line = txtline.split(' ')
    if line[0] is "B":
        #this is gross, but is required for mixed float and int types.
        xpos = int(round(float(line[3])))
        ypos = int(round(float(line[4])))
        
        if line[2] == "F":
            beecolor = foragercolor
        elif line[2] == "F+":
            beecolor = foragerfoodcolor
        elif line[2] == "S":
            beecolor = scoutcolor

        if not bees.has_key(line[1]):
            bees[line[1]] = wcanvas.create_rectangle(xpos, ypos,
                                                    xpos+beesize, ypos+beesize,
                                                    outline=beecolor)
        else:
            beeavatar = bees[line[1]]
            wcanvas.itemconfig(beeavatar, outline=beecolor)
            wcanvas.coords(beeavatar, xpos, ypos,
                           xpos+beesize, ypos+beesize)
    elif line[0] is "T":
        wcanvas.update()
    elif line[0] is "F":
        #if not dead
        if not line[2] == "D":
            xpos = int(round(float(line[2])))
            ypos = int(round(float(line[3])))
            quality = int(line[4])

            if(quality == lowflowerquality):
                flowercolor = lowqualityflowercolor
            else:
                flowercolor = highqualityflowercolor

            #flowers won't have been created already
            flowers[line[1]] = wcanvas.create_rectangle(xpos, ypos,
                                                       xpos+beesize, ypos+beesize,
                                                       outline=flowercolor)
        else:
            if flowers.has_key(line[1]):
                wcanvas.delete(flowers[line[1]])
                del flowers[line[1]]

    elif line[0] is "W":
        wcanvas = Canvas(master, width=line[1], height=line[1])
        wcanvas.pack()
    else:
        if txtline.find("#") == -1 and line != "" and line != "\n":
            print txtline,


